config/routes.rb
require 'avalon/routing/can_constraint'

Rails.application.routes.draw do
  mount Samvera::Persona::Engine => '/'
  mount Blacklight::Engine => '/catalog'
  concern :searchable, Blacklight::Routes::Searchable.new
  concern :exportable, Blacklight::Routes::Exportable.new

  resource :catalog, only: [:index], as: 'catalog', path: '/catalog', controller: 'catalog' do
    concerns :searchable
  end

  # For some reason this needs to be after `resource :catalog` otherwise Blacklight will generate links to / instead of /catalog
  root to: "catalog#index"

  get '/mejs/:version', to: 'application#mejs'

  resources :solr_documents, only: [:show], path: '/catalog', controller: 'catalog' do
    concerns :exportable
  end

  resources :encode_records, only: [:show, :index] do
    collection do
      post :paged_index
      post :progress
    end
  end

  resources :bookmarks do
    concerns :exportable

    collection do
      delete 'clear'
      get 'delete'#, as: :delete_bookmarks
      post 'delete'
      get 'move'#, as: :move_bookmarks
      post 'move'
      get 'update_access_control'#, as: :update_access_control_bookmarks
      post 'update_access_control'
      post 'publish'#, as: :publish_bookmarks
      post 'unpublish'#, as: :unpublish_bookmarks
      get 'add_to_playlist'
      post 'add_to_playlist'
      get 'intercom_push'
      post 'intercom_push'
      get 'merge'
      post 'merge'
    end
  end

  devise_for :users, controllers: { omniauth_callbacks: 'users/omniauth_callbacks', sessions: 'users/sessions' }, format: false
  devise_scope :user do
    match '/users/auth/:provider', to: 'users/omniauth_callbacks#passthru', as: :user_omniauth_authorize, via: [:get, :post]
    Avalon::Authentication::Providers.collect { |provider| provider[:provider] }.uniq.each do |provider_name|
      match "/users/auth/#{provider_name}/callback", to: "users/omniauth_callbacks##{provider_name}", as: "user_omniauth_callback_#{provider_name}".to_sym, via: [:get, :post]
    end
  end

  mount BrowseEverything::Engine => '/browse'

  # Avalon routes
  match "/authorize", to: 'derivatives#authorize', via: [:get, :post]
  match "/authorize/:path", to: 'derivatives#authorize', via: [:get, :post]

  namespace :admin do
    resources :groups, except: [:show] do
      collection do
        put 'update_multiple'
      end
      member do
        put 'update_users'
      end
    end
    resources :collections do
      member do
        get 'edit'
        get 'remove'
        get 'items'
        get 'poster'
        post 'poster', action: :attach_poster, as: 'attach_poster'
        delete 'poster', action: :remove_poster, as: 'remove_poster'
      end
    end

    namespace :migration_report, controller: '/migration_status' do
      get '/', action: :index
      get ':class', action: :show, as: 'by_class'
      get ':id/detail', action: :detail, as: 'detail'
      get ':id/report', action: :report, as: 'report'
    end
  end

  resources :vocabulary, except: [:create, :destroy, :new, :edit]

  resources :collections, only: [:index, :show] do
    member do
      get :poster
    end
  end

  resources :media_objects, except: [:create, :update] do
    member do
      put :update, action: :update, defaults: { format: 'html' }, constraints: { format: 'html' }
      put :update, action: :json_update, constraints: { format: 'json' }
      patch :update, action: :update, defaults: { format: 'html' }, constraints: { format: 'html' }
      put :update_status
      get :progress, :action => :show_progress
      get 'content/:file', :action => :deliver_content, :as => :inspect
      get 'track/:part', :action => :show, :as => :indexed_section
      get 'section/:content', :action => :show, :as => :id_section
      get 'section/:content/stream', :action => :show_stream_details, :as => :section_stream
      get 'section/:content/embed', :to => redirect('/master_files/%{content}/embed')
      get 'tree', :action => :tree, :as => :tree
      get :confirm_remove
      get :add_to_playlist_form
      post :add_to_playlist
      patch :intercom_push
      get :manifest
      get :move_preview, defaults: { format: 'json' }, constraints: { format: 'json' }
    end
    collection do
      post :create, action: :create, constraints: { format: 'json' }
      post :set_session_quality
      get :confirm_remove
      put :update_status
      # 'delete' has special signifigance so use 'remove' for now
      delete :remove, :action => :destroy
      get :intercom_collections
    end

    # Supplemental Files
    resources :supplemental_files, except: [:new, :index, :edit]
  end

  resources :master_files, except: [:new, :index] do
    member do
      get  'thumbnail', :to => 'master_files#get_frame', :defaults => { :type => 'thumbnail' }
      get  'poster',    :to => 'master_files#get_frame', :defaults => { :type => 'poster' }

      post 'thumbnail', :to => 'master_files#set_frame', :defaults => { :type => 'thumbnail', :format => 'html' }
      post 'poster',    :to => 'master_files#set_frame', :defaults => { :type => 'poster', :format => 'html' }
      post 'still',     :to => 'master_files#set_frame', :defaults => { :format => 'html' }
      get :embed
      post 'attach_structure'
      post 'attach_captions'
      get :captions
      get :waveform
      match ':quality.m3u8', to: 'master_files#hls_manifest', via: [:get], as: :hls_manifest
      get 'structure', to: 'master_files#structure', constraints: { format: 'json' }
      post 'structure', to: 'master_files#set_structure', constraints: { format: 'json' }
      delete 'structure', to: 'master_files#delete_structure', constraints: { format: 'json' }
      post 'move'
    end

    # Supplemental Files
    resources :supplemental_files, except: [:new, :index, :edit]
  end

  match "iiif_auth_token/:id", to: 'master_files#iiif_auth_token', via: [:get], as: :iiif_auth_token

  resources :derivatives, only: [:create]
  match "/autocomplete", to: 'objects#autocomplete', via: [:get]
  match "/objects/:id", to: 'objects#show', via: [:get], :as => :objects
  match "/object/:id", to: 'objects#show', via: [:get]

  resources :playlists do
    resources :playlist_items, path: 'items', only: [:create, :update, :show] do
      get 'markers'
      get 'source_details'
      get 'related_items'
    end
    member do
      patch 'update_multiple'
      delete 'update_multiple'
      patch 'regenerate_access_token'
      get 'refresh_info'
    end
    collection do
      post 'duplicate'
      post 'paged_index'
      if Settings['variations'].present?
        post 'import_variations_playlist'
      end
    end
  end

  resources :avalon_marker, only: [:create, :show, :update, :destroy]

  resources :comments, only: [:index, :create]

  resources :playlist_items, only: [:update], :constraints => {:format => /(js|json)/}

  resources :timelines do
    member do
      patch 'regenerate_access_token'
      post 'manifest', to: 'timelines#manifest_update', constraints: { format: 'json' }
      get 'manifest', constraints: { format: 'json' }
    end
    collection do
      post 'duplicate'
      post 'paged_index'
      if Settings['variations'].present?
        post 'import_variations_timeline'
      end
    end
  end
  get '/timeliner', to: 'timelines#timeliner', as: :timeliner

  resources :dropbox, :only => [] do
    collection do
      delete :bulk_delete
    end
  end

  match "/oembed", to: 'master_files#oembed', via: [:get]

  constraints(Avalon::Routing::CanConstraint.new(:read, :about_page)) do
    mount AboutPage::Engine => '/about(.:format)', as: 'about_page'
  end
  get '/about(.:format)', to: redirect('/')
  get '/about/health.yaml', to: 'about_page/about#health', defaults: { :format => 'yaml' }
  get '/about/health(.:format)', to: redirect('/')

  constraints(Avalon::Routing::CanConstraint.new(:manage, :jobs)) do
    mount Sidekiq::Web, at: '/jobs', as: 'jobs'
  end
  get '/jobs(.:format)', to: redirect('/')
end

app/models/media_object.rb
# Copyright 2011-2020, The Trustees of Indiana University and Northwestern
#   University.  Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed
#   under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
#   CONDITIONS OF ANY KIND, either express or implied. See the License for the
#   specific language governing permissions and limitations under the License.
# ---  END LICENSE_HEADER BLOCK  ---

class MediaObject < ActiveFedora::Base
  include Hydra::AccessControls::Permissions
  include Hidden
  include VirtualGroups
  include ActiveFedora::Associations
  include MediaObjectMods
  include Avalon::Workflow::WorkflowModelMixin
  include Permalink
  include Identifier
  include MigrationTarget
  include SpeedyAF::OrderedAggregationIndex
  include MediaObjectIntercom
  include SupplementalFileBehavior
  require 'avalon/controlled_vocabulary'

  include Kaminari::ActiveFedoraModelExtension

  has_and_belongs_to_many :governing_policies, class_name: 'ActiveFedora::Base', predicate: ActiveFedora::RDF::ProjectHydra.isGovernedBy
  belongs_to :collection, class_name: 'Admin::Collection', predicate: ActiveFedora::RDF::Fcrepo::RelsExt.isMemberOfCollection

  before_save :update_dependent_properties!, prepend: true
  before_save :update_permalink, if: Proc.new { |mo| mo.persisted? && mo.published? }, prepend: true
  before_save :assign_id!, prepend: true
  after_save :update_dependent_permalinks_job, if: Proc.new { |mo| mo.persisted? && mo.published? }
  after_save :remove_bookmarks

  # Call custom validation methods to ensure that required fields are present and
  # that preferred controlled vocabulary standards are used

  # Guarantees that the record is minimally complete - ie that within the descriptive
  # metadata the title, creator, date of creation, and identifier fields are not
  # blank. Since identifier is set automatically we only need to worry about creator,
  # title, and date of creation.

  validates :collection, presence: true
  # validates :governing_policies, presence: true if Proc.new { |mo| mo.changes["governing_policy_ids"].empty? }

  validates :title, presence: true, if: :resource_description_active?
  validates :date_issued, presence: true, if: :resource_description_active?
  validate  :validate_language, if: :resource_description_active?
  validate  :validate_related_items, if: :resource_description_active?
  validate  :validate_dates, if: :resource_description_active?
  validate  :validate_note_type, if: :resource_description_active?
  validate  :report_missing_attributes, if: :resource_description_active?
  validate  :validate_rights_statement, if: :resource_description_active?

  def resource_description_active?
    workflow.completed?("file-upload")
  end

  def validate_rights_statement
    errors.add(:rights_statement, "Rights statement (#{rights_statement}) not in controlled vocabulary") unless rights_statement.nil? || ModsDocument::RIGHTS_STATEMENTS.keys.include?(rights_statement)
  end

  def validate_note_type
    Array(note).each{|i|errors.add(:note, "Note type (#{i[:type]}) not in controlled vocabulary") unless ModsDocument::NOTE_TYPES.keys.include? i[:type] }
  end

  def validate_language
    Array(language).each{|i|errors.add(:language, "Language not recognized (#{i[:code]})") unless LanguageTerm::map[i[:code]] }
  end

  def validate_related_items
    Array(related_item_url).each{|i|errors.add(:related_item_url, "Bad URL") unless i[:url] =~ URI::regexp(%w(http https))}
  end

  def validate_dates
    validate_date :date_created
    validate_date :date_issued
    validate_date :copyright_date
  end

  def validate_date(date_field)
    date = send(date_field)
    return if date.blank?
    edtf_date = Date.edtf(date)
    if edtf_date.nil? || edtf_date.class == EDTF::Unknown # remove second condition to allow 'uuuu'
      errors.add(date_field, I18n.t("errors.messages.dateformat", date: date))
    end
  end

  property :duration, predicate: ::RDF::Vocab::EBUCore.duration, multiple: false do |index|
    index.as :stored_sortable
  end
  property :avalon_resource_type, predicate: Avalon::RDFVocab::MediaObject.avalon_resource_type, multiple: true do |index|
    index.as :symbol
  end
  property :avalon_publisher, predicate: Avalon::RDFVocab::MediaObject.avalon_publisher, multiple: false do |index|
    index.as :stored_sortable
  end
  property :avalon_uploader, predicate: Avalon::RDFVocab::MediaObject.avalon_uploader, multiple: false do |index|
    index.as :stored_sortable
  end
  property :identifier, predicate: ::RDF::Vocab::Identifiers.local, multiple: true do |index|
    index.as :symbol
  end
  property :comment, predicate: ::RDF::Vocab::EBUCore.comments, multiple: true do |index|
    index.as :stored_searchable
  end

  ordered_aggregation :master_files, class_name: 'MasterFile', through: :list_source
  # ordered_aggregation gives you accessors media_obj.master_files and media_obj.ordered_master_files
  #  and methods for master_files: first, last, [index], =, <<, +=, delete(mf)
  #  and methods for ordered_master_files: first, last, [index], =, <<, +=, insert_at(index,mf), delete(mf), delete_at(index)
  indexed_ordered_aggregation :master_files

  accepts_nested_attributes_for :master_files, :allow_destroy => true

  def published?
    !avalon_publisher.blank?
  end

  def destroy
    # attempt to stop the matterhorn processing job
    self.master_files.each(&:destroy)
    self.master_files.clear
    Bookmark.where(document_id: self.id).destroy_all
    super
  end

  alias_method :'_collection=', :'collection='

  # This requires the MediaObject having an actual id
  def collection= co
    old_collection = self.collection
    self._collection= co
    self.governing_policies.delete(old_collection) if old_collection
    self.governing_policies += [co]
    if self.new_record?
      self.hidden = co.default_hidden
      self.visibility = co.default_visibility
      self.read_users = co.default_read_users.to_a
      self.read_groups = co.default_read_groups.to_a + self.read_groups #Make sure to include any groups added by visibility
    end
  end

  # Sets the publication status. To unpublish an object set it to nil or
  # omit the status which will default to unpublished. This makes the act
  # of publishing _explicit_ instead of an accidental side effect.
  def publish!(user_key)
    self.avalon_publisher = user_key.blank? ? nil : user_key
    save!
  end

  def finished_processing?
    self.master_files.all?{ |master_file| master_file.finished_processing? }
  end

  def set_duration!
    self.duration = calculate_duration.to_s
  end

  def missing_attributes
    @missing_attributes ||= {}
  end

  def report_missing_attributes
    missing_attributes.each_pair { |a,m| errors.add a, m }
  end

  def set_media_types!
    mime_types = master_files.reject {|mf| mf.file_location.blank? }.collect { |mf|
      Rack::Mime.mime_type(File.extname(mf.file_location))
    }.uniq
    self.format = mime_types.empty? ? nil : mime_types
  end

  def set_resource_types!
    self.avalon_resource_type = master_files.reject {|mf| mf.file_format.blank? }.collect{ |mf|
      case mf.file_format
      when 'Moving image'
        'moving image'
      when 'Sound'
        'sound recording'
      else
        mf.file_format.downcase
      end
    }.uniq
  end

  def update_dependent_properties!
    self.set_duration!
    self.set_media_types!
    self.set_resource_types!
  end

  def all_comments
    comment.sort + ordered_master_files.to_a.compact.collect do |mf|
      mf.comment.reject(&:blank?).collect do |c|
        mf.display_title.present? ? "[#{mf.display_title}] #{c}" : c
      end.sort
    end.flatten.uniq
  end

  def section_labels
    all_labels = master_files.collect{|mf|mf.structural_metadata_labels << mf.title}
    all_labels.flatten.uniq.compact
  end

  # Gets all physical descriptions from master files and returns a uniq array
  # @return [Array<String>] A unique list of all physical descriptions for the media object
  def section_physical_descriptions
    all_pds = []
    self.master_files.each do |master_file|
      all_pds += Array(master_file.physical_description) unless master_file.physical_description.nil?
    end
    all_pds.uniq
  end

  def to_solr
    super.tap do |solr_doc|
      solr_doc[ActiveFedora.index_field_mapper.solr_name("workflow_published", :facetable, type: :string)] = published? ? 'Published' : 'Unpublished'
      solr_doc[ActiveFedora.index_field_mapper.solr_name("collection", :symbol, type: :string)] = collection.name if collection.present?
      solr_doc[ActiveFedora.index_field_mapper.solr_name("unit", :symbol, type: :string)] = collection.unit if collection.present?
      solr_doc['read_access_virtual_group_ssim'] = virtual_read_groups + leases('external').map(&:inherited_read_groups).flatten
      solr_doc['read_access_ip_group_ssim'] = collect_ips_for_index(ip_read_groups + leases('ip').map(&:inherited_read_groups).flatten)
      solr_doc[Hydra.config.permissions.read.group] ||= []
      solr_doc[Hydra.config.permissions.read.group] += solr_doc['read_access_ip_group_ssim']
      solr_doc["title_ssort"] = self.title
      solr_doc["creator_ssort"] = Array(self.creator).join(', ')
      solr_doc["date_digitized_sim"] = master_files.collect {|mf| mf.date_digitized }.compact.map {|t| Time.parse(t).strftime "%F" }
      solr_doc["date_ingested_sim"] = self.create_date.strftime "%F" if self.create_date.present?
      #include identifiers for parts
      solr_doc["other_identifier_sim"] +=  master_files.collect {|mf| mf.identifier.to_a }.flatten
      #include labels for parts and their structural metadata
      solr_doc['section_id_ssim'] = ordered_master_file_ids

app/views/media_objects/_add_to_playlist_form.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<!-- contents for add_to_playlist modal form ---->
<div class="modal-dialog" role="document">
  <div class="modal-content">
    <div class="modal-header">
      <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span
          aria-hidden="true">&times;</span></button>
      <h4 class="modal-title">Add <%= scope=='master_file'? 'Section' : 'Item'%> to Playlist</h4>
    </div>
    <div class="modal-body">
      <form id="add_to_playlist_form" action="<%= add_to_playlist_media_object_path(@media_object) %>"
        accept-charset="UTF-8" data-remote="true" method="post">
        <input type="hidden" name="post[masterfile_id]" value="<%= masterfile_id %>" />
        <div class="form-group">
          <label for="playlist">Playlist</label>
          <% @add_playlist_item_playlists = Playlist.where(user: current_user).sort_by(&:title) %>
          <%= collection_select(:post, :playlist_id, @add_playlist_item_playlists, :id, :title, {}, {id: 'add-to-playlist-playlist-id', class: "form-control form-model", style: 'width:100%;'}) %>
        </div>
        <div class="form-group">
          <label>Playlist Item Scope</label>

          <div class="radio">
            <label>
              <input type="radio" value="section" name="post[playlistitem_scope]" id="playlistitem_scope_section"
                checked="true">
              Create single item for
              <%= 'each ' if scope != 'master_file' %>section<%= " (#{stream_label_for(MasterFile.find(masterfile_id))})" if scope == 'master_file' %>
            </label>
          </div>
          <div class="radio">
            <label>
              <input type="radio" value="structure" name="post[playlistitem_scope]" id="playlistitem_scope_structure">
              Create multiple items from subsections, if available
            </label>
          </div>

        </div>
      </form>
    </div>
    <div class="modal-footer">
      <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
      <input type="submit" form="add_to_playlist_form" name="commit" data-loading-text="Working..." value="Add to Playlist" class="btn btn-primary"
        id="playlistitem_submit">
    </div>
  </div><!-- /.modal-content -->
</div><!-- /.modal-dialog -->

<script type="text/javascript">
  $('#add-to-playlist-playlist-id').select2({
    dropdownParent: $('#add-to-playlist-modal')
  });
</script>

app/views/media_objects/_administrative_links.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% if can? :update, @media_object %>
<div class="row-fluid">
  <p>
    <ul class="unstyled hidden">
      <li>
        <% if @media_object.published? %>
        <span class="label label-success">Published</span> Authorized users can view the item</li>
      <% else %>
      <span class="label label-important">Unpublished</span> Users cannot view the item</li>
      <% end %>
      <li>
        <% unless @media_object.discover_groups.include? "nobody" %>
        <span class="label label-success">Visible</span> Users can search for the item</li>
      <% else %>
      <span class="label label-important">Hidden</span> Users cannot search for the item</li>
      <% end %>
    </ul>
  </p>

  <div id="administrative_options" style="margin-bottom:1em;">

    <%= link_to 'Edit', edit_media_object_path(@media_object), class: 'btn btn-primary' %>

    <% if @media_object.published? %>
    <% if can?(:unpublish, @media_object) %>
    <%= link_to 'Unpublish', update_status_media_object_path(@media_object, status:'unpublish'), method: :put, class: 'btn btn-default' %>
    <% end %>
    <% else %>
    <%= link_to 'Publish', update_status_media_object_path(@media_object, status:'publish'), method: :put, class: 'btn btn-default' %>
    <% end %>

    <%# This might not be the best approach because it makes accidental
            deletion possible just by following a link. Need to revisit when
            extra cycles are available %>

    <% if can? :destroy, @media_object %>
    <%= link_to 'Delete', confirm_remove_media_object_path(@media_object), class: 'btn btn-link' %>
    <% end %>

    <% if Settings.intercom.present? and can? :intercom_push, @media_object %>
    <%= button_tag(Settings.intercom['default']['push_label'], class: 'btn btn-default', data: {toggle:"modal", target:"#intercom_push"}) %>
    <%= render "intercom_push_modal" %>
    <% end %>
  </div>
</div>
<% end %>

app/views/media_objects/_embed_resource.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% if section=='tab-content' %>

    <div class="tab-pane" id="embed-tab">
      <% if @currentStream.present? %>
      <p class="muted">Copy the text below to embed this resource</p>
      <textarea class="col-md-6" rows="3" id="embed-part" onClick="this.select();" readonly="readonly"><%= @currentStream.embed_code(MasterFile::EMBED_SIZE[:medium], { urlappend: '/embed' }) %></textarea>
      <% else %>
      <p class="muted"> <%= I18n.t('media_object.empty_share_link_notice') %> </p>
      <% end %>
    </div>

<% elsif section=='share-tabs' %>

    <li><a href="#embed-tab" data-toggle="tab">Embed</a></li>

<% end %>

app/views/media_objects/_intercom_push_form.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% require 'ostruct' %>
<% @collections = session[:intercom_collections] || Avalon::Intercom.new(user_key).user_collections %>
<% @collections.map! { |c| OpenStruct.new(c) } %>
<div class="modal-header">
  <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
  <h1><%= Settings.intercom['default']['push_label'] %></h1>
</div>

<div class="modal-body">
  <div class="form-group">
    <label for "collection_id">Choose Target Collection:</label>
    <div class="input-group">
      <%= select_tag :collection_id, options_from_collection_for_select(@collections, "id", "name", session[:intercom_default_collection] ), required: true, style: 'width:100%;', class:'form-control', form:'intercom_push_form' %>
      <span class="input-group-btn">
        <button class="btn btn-secondary" title="Refresh list" onclick="getIntercomCollections(true, '<%= intercom_collections_media_objects_path %>');"><i class="fa fa-refresh"></i></button>
      </span>
    </div>
  </div>
  <div class="form-group">
    <label for "include_structure_1">Include Structural Metadata?</label>
    <div class="form-check">
      <label class="form-check-label">
        <input class="form-check-input" type="radio" name="include_structure" id="include_structure_1" value="true" checked form="intercom_push_form">
        Yes, include structure.
      </label>
    </div>
    <div class="form-check">
      <label class="form-check-label">
        <input class="form-check-input" type="radio" name="include_structure" id="include_structure_2" value="false" form="intercom_push_form">
        No, do not include structure.
      </label>
    </div>
  </div>
  <div class="form-group">
    <button class="btn btn-primary" form="intercom_push_form" data-loading-text="<i class='fa fa-spinner fa-spin '></i> Pushing" id="intercom_push_submit_button" onclick="$(this).button('loading')">Push</button>
    <button data-dismiss="modal" aria-hidden="true" class="btn btn-danger">Cancel</button>
  </div>
</div>

app/views/media_objects/_multipart_dropdown_field.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% selected_value ||= options[:dropdown_options].keys.first %>
<% fieldarray = options[:multivalued]? "[]" : "" %>

<div class="input-group-btn">
  <button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown">
    <span><%= options[:dropdown_options][selected_value] %></span> <span class="caret"></span>
  </button>
  <%= hidden_field_tag "media_object[#{options[:dropdown_field]}]#{fieldarray}", selected_value %>
  <ul class="dropdown-menu" role="menu">
    <% options[:dropdown_options].each_pair do |value, display| %>
    <li><a class="dropdown-field"><%= display %></a><span class="hidden"><%= value %></li>
    <% end %>
  </ul>
</div>